#/////////////////////////////////////////////////////////////////////////////////
# convertLaunch.tcl 1.0
# 批量转换 UI 界面
#
#/////////////////////////////////////////////////////////////////////////////////

package require capAppUtils 1.0
package provide convertLaunch 1.0

namespace eval ::convertLaunch {
    variable mForm
    variable mSourcePath
    variable mOutputPath
    # 转换类型
    variable flag
}

proc seesionLog {str} {
    DboState_WriteToSessionLog [DboTclHelper_sMakeCString $str]
}

# require Tk
proc ::convertLaunch::tk_init {} {
    if { [catch {package require Tk 8.4}] } {
        set lMessage [DboTclHelper_sMakeCString [capGetInstallMessage]]
        DboState_WriteToSessionLog $lMessage
    } else {
        update
        # 把 Tk 窗口隐藏了
        wm withdraw .
    }
}

# DSN 转换界面
proc ::convertLaunch::DSN_UI {pForm} {
    # 保存变量到函数外部
    set ::convertLaunch::mForm $pForm

    # 按钮区域
    variable lLabelFrameButtons [labelframe $pForm.lLabelFrameButtons ]

    # 源文件路径输入提示提示
    variable lLabelSourcePath [label $pForm.lLabelSourcePath \
        -text "Source Directory :"]

    set lState "normal"

    # 源文件路径输入
    variable lSourcePath [entry $pForm.lSourcePath \
        -textvariable "::convertLaunch::mSourcePath" \
        -state $lState \
        -width 40 \
    ]

# 源文件路径选择
variable lBtnSourcePath [button $pForm.lBtnSourcePath \
    -activebackground "#00ffff" \
    -anchor "ne" \
    -borderwidth 1 \
    -command "convertLaunch::doChooseSourceFile" \
    -compound "left" \
    -cursor "arrow" \
    -default "active" \
    -justify "left" \
    -padx 0 \
    -pady 0 \
    -text " Browse... "]

# 输出文件路径提示
variable lLabelOutputPath [label $pForm.lLabelOutputPath \
    -text "Output Directory :"]

set lState "normal"

# 输出文件路径输入框
variable lOutputPath [entry $pForm.lOutputPath \
    -textvariable "::convertLaunch::mOutputPath" \
    -state $lState \
    -width 40 \
]

# 输出文件路径选择
variable lBtnOutputPath [button $pForm.lBtnOutputPath \
    -activebackground "#00ffff" \
    -anchor "ne" \
    -borderwidth 1 \
    -command "convertLaunch::doChooseOutputFile" \
    -compound "left" \
    -cursor "arrow" \
    -default "active" \
    -justify "left" \
    -padx 0 \
    -pady 0 \
    -text " Browse... "]

# 确认按钮
variable lBtnTranslate [button $pForm.lBtnTranslate \
    -command "convertLaunch::doTranslate" \
    -state $lState \
    -width 12 \
    -text "Translate"]

# 取消按钮
variable lBtnClose [button $pForm.lBtnClose \
    -command "convertLaunch::doClose" \
    -state $lState \
    -width 12 \
    -text "Close"]

# 位置控制

# 源文件路径输入提示提示
grid $pForm.lLabelSourcePath -in $pForm -row 1 -column 1 \
    -columnspan 1 \
    -ipadx 0 \
    -ipady 0 \
    -padx 6 \
    -pady 0 \
    -rowspan 1 \
    -sticky "w"
# 源文件路径输入
grid $pForm.lSourcePath -in $pForm -row 1 -column 2 \
    -columnspan 1 \
    -ipadx 0 \
    -ipady 0 \
    -padx 0 \
    -pady 0 \
    -rowspan 1 \
    -sticky "ew"
# 源文件路径选择
grid $pForm.lBtnSourcePath -in $pForm -row 1 -column 3 \
    -columnspan 1 \
    -ipadx 1 \
    -ipady 1 \
    -padx 10 \
    -pady 5 \
    -rowspan 1 \
    -sticky ""

# 输出文件路径提示
grid $pForm.lLabelOutputPath -in $pForm -row 2 -column 1 \
    -columnspan 1 \
    -ipadx 0 \
    -ipady 0 \
    -padx 6 \
    -pady 0 \
    -rowspan 1 \
    -sticky "w"
# 输出文件路径输入框
grid $pForm.lOutputPath -in $pForm -row 2 -column 2 \
    -columnspan 1 \
    -ipadx 0 \
    -ipady 0 \
    -padx 0 \
    -pady 0 \
    -rowspan 1 \
    -sticky "ew"
# 输出文件路径选择
grid $pForm.lBtnOutputPath -in $pForm -row 2 -column 3 \
    -columnspan 1 \
    -ipadx 1 \
    -ipady 1 \
    -padx 10 \
    -pady 5 \
    -rowspan 1 \
    -sticky ""

# 按钮区域
grid $pForm.lLabelFrameButtons -in $pForm -row 3 -column 1 \
    -columnspan 3 \
    -ipadx 0 \
    -ipady 0 \
    -padx 0 \
    -pady 0 \
    -rowspan 1 \
    -sticky "news"

# 确认按钮
grid $pForm.lBtnTranslate -in $pForm.lLabelFrameButtons -row 1 -column 1 \
    -columnspan 1 \
    -ipadx 1 \
    -ipady 1 \
    -padx 6 \
    -pady 6 \
    -rowspan 1 \
    -sticky "w"
# 取消按钮
grid $pForm.lBtnClose -in $pForm.lLabelFrameButtons -row 1 -column 2 \
    -columnspan 1 \
    -ipadx 1 \
    -ipady 1 \
    -padx 6 \
    -pady 6 \
    -rowspan 1 \
    -sticky "w"

# 调整容器大小时的变化
grid rowconfigure $pForm 1 -weight 0 -minsize 21 -pad 0
grid rowconfigure $pForm 2 -weight 0 -minsize 21 -pad 0
grid rowconfigure $pForm 2 -weight 0 -minsize 9 -pad 0
grid columnconfigure $pForm 1 -weight 0 -minsize 10 -pad 0
grid columnconfigure $pForm 2 -weight 1 -minsize 40 -pad 0
grid columnconfigure $pForm 3 -weight 0 -minsize 10 -pad 0
grid rowconfigure $pForm.lLabelFrameButtons 1 -weight 0 -minsize 12 -pad 0
grid columnconfigure $pForm.lLabelFrameButtons 1 -weight 0 -minsize 12 -pad 0
grid columnconfigure $pForm.lLabelFrameButtons 2 -weight 0 -minsize 12 -pad 0
}

# 选择源文件路径
proc convertLaunch::doChooseSourceFile {  } {
    set path [tk_chooseDirectory \
        -title "Select Source Directory"]
    set path [string map {/ \\} $path]; # 用户输入的路径也这样处理？
    seesionLog $path

    set ::convertLaunch::mSourcePath $path
}

# 选择保存文件路径
proc convertLaunch::doChooseOutputFile {  } {
    set path [tk_chooseDirectory \
        -title "Select Output Directory"]
    set path [string map {/ \\} $path]
    seesionLog $path
    set ::convertLaunch::mOutputPath $path
}

# 确认按钮回调
proc convertLaunch::doTranslate { } {
    # 校验目录值
    if { $::convertLaunch::mSourcePath == "" } {
        tk_alert "Source directory cannot be empty."
        return
    }
    if { $::convertLaunch::mOutputPath == "" } {
        tk_alert "Output directory cannot be empty."
        return
    }

    switch $::convertLaunch::flag {
        "dsn" {
            tcl_dsn2edif $::convertLaunch::mSourcePath $::convertLaunch::mOutputPath ""
        }
        "olb" {
            tcl_olb2xml $::convertLaunch::mSourcePath $::convertLaunch::mOutputPath
        }
        default {
            seesionLog "nomatch flag:$::convertLaunch::flag"
        }
    }

    destroy $::convertLaunch::mForm
}

# 取消按钮回调
proc convertLaunch::doClose {  } {
    destroy $::convertLaunch::mForm
}

# 加载 DSN 转换界面
proc ::convertLaunch::DSN_Launch {} {
    ::convertLaunch::tk_init

    # 创建一个 DSN 转换窗口
    set lForm .convertWindow
    capAppUtils::capTopLevel $lForm
    wm title $lForm {DSN To EDIF}

    # 添加 UI 控件
    convertLaunch::DSN_UI $lForm

    wm resizable $lForm 0 0
    capAppUtils::autoAdoptWindow $lForm
    set ::convertLaunch::flag "dsn"
}

# 加载 OLB 转换界面
proc ::convertLaunch::OLB_Launch {} {
    ::convertLaunch::tk_init

    # 创建一个 OLB 转换窗口
    set lForm .convertWindow
    capAppUtils::capTopLevel $lForm
    wm title $lForm {OLB To XML}

    # 添加 UI 控件
    convertLaunch::DSN_UI $lForm

    wm resizable $lForm 0 0
    capAppUtils::autoAdoptWindow $lForm
    set ::convertLaunch::flag "olb"
}
